/***
 * C++ equivalent of <code>ControlMessage</code> in Java
 * Basic constants to help define message types, as well as
 * constants declaring data types.
 *
 * @author K Ericson
 */

#ifndef CONSTANTS_H_
#define CONSTANTS_H_

const int ABORT = 0;
const int START_STOP = 1;
const int PAUSE_RESUME = 2;
const int STATUS = 3;
const int COMPLETE = 4;

const int DATA = 5;
const int RESULTS = 6;
const int INITIALIZE = 7;
const int CHANGE_BRIDGE_TYPE = 8;

const int LONG = -1;
const int STRING = -2;

const int UPIPES = 0;
const int TCP = 2;

#endif
