#wrapper to handle simple fibonacci example
# this is responsible for controlling the linked program (pyFib)
# this would need to be modified when linking to a different program
# - K Ericson ericson@cs.colostate.edu

import sys
from javaMessage import *
import time

class fibWrap:
	#_jm_ = javaMessage()
	"""Initialize from a javaMessage"""
	def __init__(self,jm):
		_jm_ = javaMessage()
		self.stream = jm.StreamID
		self.status = "INITIALIZED"
		self.input = jm.IOArray[0].data
		tmp = _jm_.dataBlock.parse(self.input)
		#sys.stderr.write(str(tmp))
		sys.stderr.write("done initializing")
		sys.stderr.flush()
	def run(self, jm):
		_jm_ = javaMessage()
		#c = colMap()
		io = jm.IOArray
		self.input = io[0].data
		sys.stderr.write("running!!!\n")
		sys.stderr.write("input:\n" + str(self.input) + "\n")
		sys.stderr.flush()
		allInp = _jm_.dataBlock.parse(self.input)
		sys.stderr.write(str(allInp) + "\n")
		sys.stderr.flush()
		#input should contain in this order:
		#INT(toFib)
		self.status = "RUNNING"
		toFib = allInp.readOne[0].data
		startTime = time.time() * 1000000
		result = fib(toFib)
		#done with actual running now, so now get time difference..
		timeDiff = (time.time() * 1000000) - startTime
		list = []
		list.insert(0,Container(DataType="LONG",data=result))
		list.append(Container(DataType="LONG",data=timeDiff))
		self.results = _jm_.dataBlock.build(Container(readOne=list))
		#sys.stderr.write("checking back output: " + str(_jm_.dataBlock.parse(self.results)) + "\n")
		#sys.stderr.flush()
		self.status = "COMPLETED"
	def getResults(self):
		_jm_ = javaMessage()
		x = _jm_.JMConvert.build(Container(MessageType="RESULTS",IOArray=[Container(length=len(self.input),data = self.input),Container(length=len(self.results),data=self.results)],StreamID = self.stream,Description=self.status,fromJava=False))
		sys.stderr.write("return msg size: " + str(len(x)) + "\n")
		sys.stderr.flush()
		return x

