//helper programs, generall from NaradaBrokering-CPP-Bridge
//minor changes only
#ifndef _HELPERS_CPP_
#define _HELPERS_CPP_

/***
 * Set of helper functions to convert from <code>char*</code>(<code>byte[]</code>) to primitives and vice versa
 * @author K Ericson
 */

#include <stdio.h>

//From NaradaBrokering-CPP-Bridge


long long readLong( char *buf){
	long long one=(*(buf))&0x00000000000000FF;
	long long two=(*(buf+1))&0x00000000000000FF;
	long long three=(*(buf+2))&0x00000000000000FF;
	long long four=(*(buf+3))&0x00000000000000FF;	
	long long five=(*(buf+4))&0x00000000000000FF;	
	long long six=(*(buf+5))&0x00000000000000FF;	
	long long seven=(*(buf+6))&0x00000000000000FF;	
	long long eight=(*(buf+7))&0x00000000000000FF;	
			
	return (long long)((one<<56)+(two<<48)+(three<<40)+(four<<32)+(five<<24)+(six<<16)+(seven<<8)+(eight));
	
};


int readInt( char* buf)
{
	int ret = -1;
	int one=(*(buf))&0x000000ff;
	int two=(*(buf+1))&0x000000ff;
	int three=(*(buf+2))&0x000000ff;
	int four=(*(buf+3))&0x000000ff;
	ret = ((one<<24)+(two<<16)+(three<<8)+(four));
	return ret;
};

void writeInt( char *buff ,int integer,int &offset){
    	 char ch=( char)(((integer)>>24)& 0x000000FF);
		memcpy(buff,&ch,1);
		
		ch=( char)(((integer)>>16)& 0x000000FF);
		memcpy(buff+1,&ch,1);
		
		ch=( char)(((integer)>>8)& 0x000000FF);
		memcpy(buff+2,&ch,1);
		
		ch=( char)((integer)& 0x000000FF);
		memcpy(buff+3,&ch,1);	
		
		offset+=4;			
};



void writeLong( char *buff, long long long_val, int &offset){
	long long temp;
	temp=(((long_val)>>56)& 0x00000000000000FF);
	 char ch=( char)temp;
	memcpy(buff,&ch,1);
	
	temp=(((long_val)>>48)& 0x00000000000000FF);
	ch=( char)temp;
	memcpy(buff+1,&ch,1);
	
	temp=(((long_val)>>40)& 0x00000000000000FF);
	ch=( char)temp;
	memcpy(buff+2,&ch,1);
	
	temp=(((long_val)>>32)& 0x00000000000000FF);
	ch=( char)temp;
	memcpy(buff+3,&ch,1);
	
	temp=(((long_val)>>24)& 0x00000000000000FF);
	ch=( char)temp;
	memcpy(buff+4,&ch,1);
	
	temp=(((long_val)>>16)& 0x00000000000000FF);
	ch=( char)temp;
	memcpy(buff+5,&ch,1);
	
	temp=(((long_val)>>8)& 0x00000000000000FF);
	ch=( char)temp;
	memcpy(buff+6,&ch,1);
	
	temp=(long_val & 0x00000000000000FF);
	ch=( char)temp;
	memcpy(buff+7,&ch,1);
	offset+=8;

};


#endif //_HELPERS_CPP_
