﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace csBridge
{
    /*
     * Set of constants used in Bridge communication
     */
    static class ControlMessage
    {
        //basic communication
        public const int ABORT = 0;
        public  const int START_STOP = 1;
        public  const int PAUSE_RESUME = 2;
        public  const int STATUS = 3;
        public const int COMPLETE = 4;

        //possibly data-heavy commands
        public  const int DATA = 5;
        public  const int RESULTS = 6;
        public  const int INITIALIZE = 7;

        //data types (for passing input/output)
        public  const int LONG = -1;
        public  const int STRING = -2;
    }
}
