#main entrance point for the reducer for unnamed pipes

import sys
from construct import*
from javaMessage import*
import colWrap
import time

cin = sys.stdin
cout = sys.stdout
cerr = sys.stderr

cerr.write("starting up...")
cerr.flush()
jm = javaMessage()
while(True):
	insize = cin.read(4) #first 4 bytes are the length of the rest of the msg
	length=SBInt32("size").parse(insize)
	incoming = cin.read(length)
	msg = jm.JMConvert.parse(incoming)
	mtype = msg.MessageType
	if(mtype=="INITIALIZE"):
		crw=colWrap.colRdcrWrap(msg)
		retData = jm.dataBlock.build(Container(readOne=[Container(DataType="STRING",data=crw.status)]))
		retMsg=jm.JMConvert.build(Container(MessageType="STATUS",IOArray=[Container(length=len(msg.IOArray[0].data),data=msg.IOArray[0].data),Container(length=len(retData),data=retData)],StreamID=crw.stream,Description=crw.status,fromJava=False))
		r = jm.finalBuild.build(Container(length=len(retMsg),data=retMsg))
		cout.write(r)
		cout.flush()

	elif(mtype=="START_STOP"):
		retMsg = crw.run(msg)
		#retData = jm.dataBlock.build(Container(readOne=[Container(DataType="STRING",data=crw.status)]))
		#retMsg=jm.JMConvert.build(Container(MessageType="STATUS",IOArray=[Container(length=len(msg.IOArray[0].data),data=msg.IOArray[0].data),Container(length=len(retData),data=retData)],StreamID=crw.stream,Description=crw.status,fromJava=False))
		r = jm.finalBuild.build(Container(length=len(retMsg),data=retMsg))
		cout.write(r)
		cout.flush()

	elif(mtype=="RESULTS"):
		rm = crw.getResults(msg)
		r = jm.finalBuild.build(Container(length=len(rm),data = rm))
		cout.write(r)
		cout.flush()
	elif(mtype=="ABORT"):
		cerr.write("Killing...")
		break
	else:
		cerr.write("Unhandled msg type")
		cerr.flush()
		retData = jm.dataBlock.build(Container(readOne=[Container(DataType="STRING",data=crw.status)]))
		retMsg=jm.JMConvert.build(Container(MessageType="STATUS",IOArray=[Container(length=len(msg.IOArray[0].data),data=msg.IOArray[0].data),Container(length=len(retData),data=retData)],StreamID=crw.stream,Description=crw.status,fromJava=False))
		r = jm.finalBuild.build(Container(length=len(retMsg),data=retMsg))
		cout.write(r)
		cout.flush()		
